=== requirements.txt ===
pyyaml
msgpack
