=== deps/requirements.txt ===
pyyaml
msgpack
six
wheel
virtualenv
