=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries librocblas0-tests
Depends: librocblas0-tests, libopenblas0-pthread, rocminfo
Restrictions: skippable, allow-stderr, needs-sudo
Architecture: amd64
