=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//,oversionmangle=s/(.*)/$1+dfsg/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocblas-$1.tar.gz%" \
    https://github.com/rocm/rocblas/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
opts="dversionmangle=s/\+dfsg//,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%tensile-$1.tar.gz%, component=tensile" \
    https://github.com/rocm/tensile/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz same
